#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
# Set this so that find-lang.sh will recognize the .po files.
%global		gettext_domain mit-krb5
#-----------------------------------------------------------------------------
Name		:	krb5
Version		:	1.19.3
Release		:	16.2.0.rel%{?dist}
Summary		:	The Kerberos network authentication system

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://kerberos.org/dist/krb5

Source0		:	%{name}-%{version}.tar.gz
Patch0		:	%{name}-%{version}-openssl3_fixes-1.patch
#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	bison
BuildRequires	:	cmake
BuildRequires	:	e2fsprogs
BuildRequires	:	flex
BuildRequires	:	gcc
BuildRequires	:	openldap-devel
BuildRequires	:	pkg-config
BuildRequires	:	sed
#-----------------------------------------------------------------------------
%description
Kerberos V5 is a trusted-third-party network authentication
system, which can improve your network's security by
eliminating the insecure practice of sending passwords over
the network in unencrypted form.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)

%post
/usr/sbin/ldconfig

%postun
/usr/sbin/ldconfig

#=============================================================================
%package		devel
Summary		:	Development files needed to compile Kerberos 5 programs

#-----------------------------------------------------------------------------
Requires	:	 %{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Kerberos is a network authentication system. The krb5-devel package
contains the header files and libraries needed for compiling Kerberos
5 programs. If you want to develop Kerberos-aware programs, you need
to install this package.

#-----------------------------------------------------------------------------
%files			devel
%{_bindir}/krb5-config
%{_includedir}/*.h
%{_includedir}/gssapi/*.h
%{_includedir}/gssrpc/*.h
%{_includedir}/kadm5/*.h
%{_includedir}/krb5/*.h
%{_libdir}/libverto.so
%{_libdir}/libgssapi_krb5.so
%{_libdir}/libgssrpc.so
%{_libdir}/libk5crypto.so
%{_libdir}/libkdb5.so
%{_libdir}/libkrad.so
%{_libdir}/libkrb5.so
%{_libdir}/libkrb5support.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man1/krb5-config.1.gz

#=============================================================================
%package		libs
Summary		:	The non-admin shared libraries used by Kerberos 5

#-----------------------------------------------------------------------------
Requires	:	coreutils
Requires	:	openssl-libs

#-----------------------------------------------------------------------------
%description		libs
Kerberos is a network authentication system. The krb5-libs package
contains the shared libraries needed by Kerberos 5. If you are using
Kerberos, you need to install this package.

#-----------------------------------------------------------------------------
%files			libs -f %{gettext_domain}.lang

%{_libdir}/libgssapi_krb5.so.*
%{_libdir}/libgssrpc.so.*
%{_libdir}/libk5crypto.so.*
%{_libdir}/libkdb5.so.*
%{_libdir}/libkrad.so.*
%{_libdir}/libkrb5.so.*
%{_libdir}/libverto.so.*
%{_libdir}/libkrb5support.so.*
%{_libdir}/krb5/plugins/tls/k5tls.so
%{_libdir}/krb5/plugins/preauth/spake.so

%{_mandir}/man5/.k5identity.5.gz
%{_mandir}/man5/.k5login.5.gz
%{_mandir}/man5/k5identity.5.gz
%{_mandir}/man5/k5login.5.gz
%{_mandir}/man5/krb5.conf.5.gz
%{_mandir}/man7/kerberos.7.gz

#=============================================================================
%package		server
Summary		:	The KDC and related programs for Kerberos 5

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	=	%{version}-%{release}
Requires	:	openssl-libs

#-----------------------------------------------------------------------------
%description		server
Kerberos is a network authentication system. The krb5-server package
contains the programs that must be installed on a Kerberos 5 key
distribution center (KDC).  If you are installing a Kerberos 5 KDC,
you need to install this package (in other words, most people should
NOT install this package).

#-----------------------------------------------------------------------------
%files			server
%{_bindir}/sclient
%{_sbindir}/sserver
%{_libdir}/krb5/plugins/preauth/otp.so
%{_libdir}/krb5/plugins/kdb/db2.so
%{_mandir}/man1/sclient.1.gz
%{_mandir}/man8/sserver.8.gz
#=============================================================================
%package		workstation
Summary		:	Kerberos 5 programs for use on workstations

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		workstation
Kerberos is a network authentication system. The krb5-workstation
package contains the basic Kerberos programs (kinit, klist, kdestroy,
kpasswd). If your network uses Kerberos, this package should be
installed on every workstation.

#-----------------------------------------------------------------------------
%files			workstation
%{_bindir}/kdestroy
%{_bindir}/kinit
%{_bindir}/klist
%{_bindir}/kpasswd
%{_bindir}/kswitch
 
%{_bindir}/kvno
%{_bindir}/kadmin
%{_bindir}/k5srvutil
%{_bindir}/ktutil

%attr(4755,root,root) %{_bindir}/ksu

%{_sbindir}/kadmin.local
%{_sbindir}/kadmind
%{_sbindir}/kdb5_util
%{_sbindir}/kprop
%{_sbindir}/kpropd
%{_sbindir}/kproplog
%{_sbindir}/krb5kdc

%{_datadir}/examples/%{name}/*
%{_mandir}/man5/kadm5.acl.5*
%{_mandir}/man1/kdestroy.1.gz
%{_mandir}/man1/klist.1.gz
%{_mandir}/man1/kinit.1.gz
%{_mandir}/man1/kpasswd.1.gz
%{_mandir}/man1/kswitch.1.gz
%{_mandir}/man1/kvno.1.gz
%{_mandir}/man1/kadmin.1.gz
%{_mandir}/man1/k5srvutil.1.gz
%{_mandir}/man1/ktutil.1.gz
%{_mandir}/man1/ksu.1.gz

%{_mandir}/man5/kdc.conf.5.gz
%{_mandir}/man8/kadmin.local.8.gz
%{_mandir}/man8/kadmind.8.gz
%{_mandir}/man8/kdb5_util.8.gz
%{_mandir}/man8/kprop.8.gz
%{_mandir}/man8/kpropd.8.gz
%{_mandir}/man8/kproplog.8.gz
%{_mandir}/man8/krb5kdc.8.gz
 
#=============================================================================
%package		pkinit
Summary		:	The PKINIT module for Kerberos 5

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		pkinit
Kerberos is a network authentication system. The krb5-pkinit
package contains the PKINIT plugin, which allows clients
to obtain initial credentials from a KDC using a private key and a
certificate.

#-----------------------------------------------------------------------------
%files			pkinit
%{_libdir}/krb5/plugins/preauth/pkinit.so

#=============================================================================
%package		server-ldap
Summary		:	The LDAP storage plugin for the Kerberos 5 KDC

#-----------------------------------------------------------------------------
Requires	:	%{name}-server	= %{version}-%{release}
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		server-ldap
Kerberos is a network authentication system. The krb5-server package
contains the programs that must be installed on a Kerberos 5 key
distribution center (KDC).  If you are installing a Kerberos 5 KDC,
and you wish to use a directory server to store the data for your
realm, you need to install this package.

#-----------------------------------------------------------------------------
%files			server-ldap
%{_sbindir}/kdb5_ldap_util
%{_libdir}/krb5/plugins/kdb/kldap.so
%{_libdir}/libkdb_ldap.so
%{_libdir}/libkdb_ldap.so.*
%{_mandir}/man8/kdb5_ldap_util.8.gz
#=============================================================================
%package -n		libkadm5
Summary		:	Kerberos 5 Administrative libraries

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description -n		libkadm5
Kerberos is a network authentication system. The libkadm5 package
contains only the libkadm5clnt and libkadm5serv shared objects. This
interface is not considered stable.

#-----------------------------------------------------------------------------
%files -n		libkadm5
%{_libdir}/libkadm5clnt.so
%{_libdir}/libkadm5clnt_mit.so
%{_libdir}/libkadm5srv.so
%{_libdir}/libkadm5srv_mit.so
%{_libdir}/libkadm5clnt_mit.so.*
%{_libdir}/libkadm5srv_mit.so.*

#=============================================================================
%prep
%setup -q
%patch0 -p1

#-----------------------------------------------------------------------------
#building application
%build

pushd src

sed -i							\
  -e 's@\^u}@^u cols 300}@'				\
  tests/dejagnu/config/default.exp

sed -i							\
  -e '/eq 0/{N;s/12 //}'				\
  plugins/kdb/db2/libdb2/test/run.test

./configure						\
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--localstatedir=%{_var}/lib			\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--with-system-et				\
	--with-system-verto=no				\
	--with-lmdb=no					\
	--with-ldap					\


%{__make} %{_smp_mflags}

popd
#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	-C src						\
	DESTDIR=%{buildroot}				\
	install

%find_lang %{gettext_domain}

for f in						\
	gssapi_krb5					\
	gssrpc						\
	k5crypto					\
	kadm5clnt					\
	kadm5srv					\
        kdb5						\
	kdb_ldap					\
	krad krb5					\
	krb5support					\
	verto 
  do
  find %{buildroot}%{_libdir} 				\
	-type f -name "lib$f*.so*"			\
	-exec chmod -v 755 {} \;    
  done

#removing binary without manual
%{__rm} -fr %{buildroot}%{_sbindir}/krb5-send-pr
%{__rm} -fr %{buildroot}%{_sbindir}/gss-server
%{__rm} -fr %{buildroot}%{_sbindir}/sim_server
%{__rm} -fr %{buildroot}%{_sbindir}/uuserver
%{__rm} -fr %{buildroot}%{_bindir}/gss-client
%{__rm} -fr %{buildroot}%{_bindir}/sim_client
%{__rm} -fr %{buildroot}%{_bindir}/uuclient

# This is only needed for tests
%{__rm} -fr %{buildroot}%{_libdir}/krb5/plugins/preauth/test.so

#-----------------------------------------------------------------------------
%changelog
